%{
	#include <stdio.h>
	#include <stdlib.h>

	#define P 0
	#define A 1
	#define B 2
	#define H1 3
	#define H2 4
	#define H3 5
	
	struct el {
		struct el* poprz;
		int n;
	};
	
	extern int n, yychar, blad;
	extern struct el** stosy;
	extern int h1i, h2i, h3i, ai, bi, pi;
%}

%token html endhtml
%token title endtitle
%token head endhead
%token p endp
%token bld endbld
%token br
%token a enda
%token body endbody
%token h1 endh1 h2 endh2 h3 endh3

%expect 6

%%

dok		:	html naglowek body reszta endbody endhtml { if (!blad) printf("Poprawny plik\n"); }
;
naglowek	:
		|	head tytul endhead
		|	head tytul { printf("Blad w linii %d: niesparowany znacznik <head>\n", n); blad=1; }
		|	tytul endhead { printf("Blad w linii %d: niesparowany znacznik </head>\n", n); blad=1; }
;
tytul		:
		|	title endtitle
		|	title { printf("Blad w linii %d: niesparowany znacznik <title>\n", n); blad=1; }
		|	endtitle { printf("Blad w linii %d: niesparowany znacznik </title>\n", n); blad=1; }
;
reszta		:
		|	p reszta endp reszta
		|	p reszta { printf("Blad w linii %d: niesparowany znacznik <p>\n", pop(P)); pi--; blad=1; }
		|	bld reszta endbld reszta
		|	bld reszta { printf("Blad w linii %d: niesparowany znacznik <b>\n", pop(B)); bi--; blad=1; }
		|	a reszta enda reszta
		|	a reszta { printf("Blad w linii %d: niesparowany znacznik <a>\n", pop(A)); ai--; blad=1; }
		|	h1 reszta endh1 reszta
		|	h1 reszta { printf("Blad w linii %d: niesparowany znacznik <h1>\n", pop(H1)); h1i--; blad=1; }
		|	h2 reszta endh2 reszta
		|	h2 reszta { printf("Blad w linii %d: niesparowany znacznik <h2>\n", pop(H2)); h2i--; blad=1; }
		|	h3 reszta endh3 reszta
		|	h3 reszta { printf("Blad w linii %d: niesparowany znacznik <h3>\n", pop(H3)); h3i--; blad=1; }
		|	br reszta
;

%%

yyerror() {
	printf("Blad krytyczny: plik nie ma struktury dokumentu HTML!\n");
}

int main() {
	int i;
	
	stosy = malloc(6*sizeof(struct el*));
	
	for (i=0; i<6; i++)
		stosy[i]=0;
	
	yyparse();
	return EXIT_SUCCESS;
}
