%{
	#include "lab2.tab.h"
	int n=1, blad;
	int h1i, h2i, h3i, bi, pi, ai;
	
	#define P 0
	#define A 1
	#define B 2
	#define H1 3
	#define H2 4
	#define H3 5
	
	struct el {
		struct el* poprz;
		int n;
	};
	
	struct el** stosy;
	
	void push(int);
%}

HOST    ([A-Za-z][a-zA-Z0-9\-]*[a-zA-Z0-9]".")*[A-Za-z][a-zA-Z0-9\-]*[a-zA-Z0-9]
IP      (([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"."){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])
PORT    [1-9]([0-9]{0,3})|[0-5]([0-9]{4})|6[0-4]([0-9]{3})|65[0-4]([0-9]{2})|655[0-2][0-9]|6553[0-5]
SERVER	("http"|"https"|"ftp")"://"({HOST}|{IP})((":"{PORT}){0,1})

%s a_error

%%
"<"[Hh][Tt][Mm][Ll]">"	return html;
"</"[Hh][Tt][Mm][Ll]">"	return endhtml;
"<"[Hh][Ee][Aa][Dd]">"	return head;
"</"[Hh][Ee][Aa][Dd]">"	return endhead;
"<"[Tt][Ii][Tt][Ll][Ee]">"	return title;
"</"[Tt][Ii][Tt][Ll][Ee]">"	return endtitle;
"<"[Bb][Oo][Dd][Yy]">"	return body;
"</"[Bb][Oo][Dd][Yy]">"	return endbody;
"<"[Pp]">"	push(P); pi++; return p;
"</"[Pp]">"	if (!pi) { printf("Blad w linii %d: niesparowany znacznik </p>\n", n); blad=1; yyless(4); } else { pi--; pop(P); return endp; }
"<"[Bb]">"	push(B); bi++; return bld;
"</"[Bb]">"	if (!bi) { printf("Blad w linii %d: niesparowany znacznik </b>\n", n); blad=1; yyless(4); } else { bi--; pop(B); return endbld; }
"<"[Aa]" "[Hh][Rr][Ee][Ff]"=\""([a-zA-Z0-9\-_\./]*|{SERVER}|({SERVER}"/"[a-zA-Z0-9\-_\./]*))"\">"	push(A); ai++; return a;
"<"[Aa]([^>]*)">"	BEGIN(a_error); printf("Blad w linii %d: nieprawidlowy format znacznika %s\n", n, yytext);
<a_error>.
<a_error>"</"[Aa]">"	BEGIN(0);
"</"[Aa]">"	if (!ai) { printf("Blad w linii %d: niesparowany znacznik </a>\n", n); blad=1; yyless(4); } else { ai--; pop(A); return enda; }
"<"[Bb][Rr]">"	return br;
"<"[hH]"1>"	push(H1); h1i++; return h1;
"</"[hH]"1>"	if (!h1i) { printf("Blad w linii %d: niesparowany znacznik </h1>\n", n); blad=1; yyless(5); } else { h1i--; pop(H1); return endh1; }
"<"[hH]"2>"	push(H2); h2i++; return h2;
"</"[hH]"2>"	if (!h2i) { printf("Blad w linii %d: niesparowany znacznik </h2>\n", n); blad=1; yyless(5); } else { h2i--; pop(H2); return endh2; }
"<"[hH]"3>"	push(H3); h3i++; return h3;
"</"[hH]"3>"	if (!h3i) { printf("Blad w linii %d: niesparowany znacznik </h3>\n", n); blad=1; yyless(5); } else { h3i--; pop(H3); return endh3; }
"<"[^/]([^>]*)">"	printf("Blad w linii %d: nieznany znacznik %s\n", n, yytext);
.
\n	n++;

%%

void push(int tag) {
	struct el* tmp = malloc(sizeof(struct el));
		
	tmp->n = n;
	tmp->poprz = stosy[tag];
	stosy[tag] = tmp;
}

int pop(int tag) {
	struct el* tmp = stosy[tag];
	int ret;
	
	ret = tmp->n;
	stosy[tag] = tmp->poprz;
	
	free(tmp);
	
	return ret;
}
