%{
	#include <stdlib.h>
	#include <stdio.h>

	int lisci, wezlow, glmax, gl;
	char* tmp;

	extern FILE* yyin;
%}

%union {
	char* nazwa;
}

%token lnawias pnawias dwukr przec
%token <nazwa> wezel
%type <nazwa> drzewo
%type <nazwa> drzewa

%%

drzewo	:	wezel { lisci++; }
	|	lnawias { gl++; if (gl>glmax) glmax++; } wezel dwukr drzewa pnawias { wezlow++; gl--; tmp = malloc(strlen($3)+strlen($5)+6); sprintf(tmp, "(%s : %s)", $3, $5); free($3); free($5); $$ = tmp; }
;

drzewa	:	drzewo przec drzewa { tmp = malloc(strlen($1)+strlen($3)+4); sprintf(tmp, "%s , %s", $3, $1); free($1); free($3); $$ = tmp; }
	|	drzewo
;

%%

yyerror() {
	fprintf(stderr, "Bledna struktura\n");
	exit(EXIT_FAILURE);
}

int main(int argc, char** argv) {
	if (argc<1) {
		fprintf(stderr, "Uzycie: %s plik\n", argv[0]);
		return EXIT_FAILURE;
	}

	yyin = fopen(argv[1], "r");

	if (!yyin) {
		fprintf(stderr, "Nie mozna otworzyc pliku\n");
		return EXIT_FAILURE;
	}

	yyparse();

	printf("%d\n%d\n%d\n%s\n", wezlow+lisci, lisci, glmax, tmp);

	return EXIT_SUCCESS;
}
